#ifndef __CAMERA_H__
#define __CAMERA_H__



/*
	  ^
	|_'
	 y
	 ^
	 |
	 |         _
	 |        v | 
	  ------> x |
	/        |__|      
       /
      z ^
        |
     '--'
*/

struct camera {
  /* Viewpoint position in world space. */
  struct point position ;
  struct point dir ;
  struct point right ;
  struct point up ;
  float d ;
};

void InitCamera (float h_aperture, float v_aperture, struct camera *out) ;
void RenderCamera (struct camera *camera) ;
void RotateCameraAroundArbitrary (struct camera *camera, struct point *axis,
				  float angle) ;
void MoveFoward (struct camera *camera) ;
void MoveBackward (struct camera *camera) ;
void ZoomReset (struct camera *camera) ;

#endif
