#ifndef __GFX_ENGINE_H__
#define __GFX_ENGINE_H__

#define CUBE_EDGE_SIZE (0.5f)

enum soft_rotation {
  X_Clocwise, X_CounterClocwise,
  Y_Clocwise, Y_CounterClocwise,
  Z_Clocwise, Z_CounterClocwise
};


#define FOV (35.0f)
#define NB_TEXTURES 5

#define METACUBE_CUBE_TEXTURE_ID 0
#define FLIPPED_CUBE_TEXTURE_ID 1
#define METACUBE_CUBE_TEXTURE_SHADED_ID 2
#define FLIPPED_CUBE_TEXTURE_SHADED_ID 3
#define DEEP_SPACE_TEXTURE_ID 4

extern int texture_ids[NB_TEXTURES] ;

extern struct sSpriteEntry global_sprites_copy[128] ;

void Init3DGfxEngine () ;
void Init2DMainGameScreen (bool show) ;
void UpdateTimer () ;
void RefreshScoreAndLines (u32 old_score, u32 old_nb_lines) ;
void DoSoftRotation (enum soft_rotation rotation) ;
void DoSoftDescent (s8 downto_y) ;
void DoRegularRendering () ;
void NotifyBadDrop () ;
void ShowDestructions () ;
void AnimateTouchOnSprite_0 (s16 at_x, s16 at_y) ;
void PrepareStylusOnSprite_1 () ;
void AnimateStylusOnSprite_1 () ;
void HideStylusOnSprite_1 () ;
void HideAllSprites () ;
bool ConfirScoreErasing () ;
void AnimateSleepingSmilesAndLoopForever () ;
void FlashBottomScreen () ;

/* It seems that for NDS, texture coords interval maps [0:1] onto 128-bits */
/* wide textures. For 64-bits-wide textures, the interval get divided by 2 */
/* leading to [0:0.5]. And so on for smaller textures.                     */
#define SCALE_TO_TEXTURE_64(x) ((x) / 2.0f)

#endif
