#ifndef __GLOBAL_H__
#define __GLOBAL_H__

extern struct camera global_camera ;

#define MINUTE5 (60 * 2 * 5)
#define MINUTE10 (60 * 2 * 10)
#define MINUTE15 (60 * 2 * 15)

#define NB_GAME_TYPES 4

enum game_type {
  Game_Type_Endless = 0,
  Game_Type_5mn = 1,
  Game_Type_10mn = 2,
  Game_Type_15mn = 3
};

enum keyboard_config { Keyboard_Config_1, Keyboard_Config_2 } ;

struct game_status {
  u32 score ;
  u32 nb_lines ;
  enum game_type game_type ;
  u16 elapsed_semi_seconds ;
};

extern struct metacube *global_current_metacube  ;
extern struct metacube *global_free_meta_cube ;
extern struct shape current_shape ;
extern struct game_status global_game ;

#define SCORE_SHAPE_DROPPED (10)
#define SCORE_LINE_DESTROYED (200)

void SetActiveCubeBuffer0 () ;
void SwapCubeBuffers () ;

#endif
