#ifndef __HIGHSCORES_FONTS_GFX_H__
#define __HIGHSCORES_FONTS_GFX_H__


/* General stuff for all score fonts. */
#define NB_HIGHSCORES_DIGITS_TILES 22
extern const u8 highscores_endless_digits_tiles
  [NB_HIGHSCORES_DIGITS_TILES * 64]
  __attribute__ ((section (".rodata"))) ;
extern const u8 highscores_5minutes_digits_tiles
  [NB_HIGHSCORES_DIGITS_TILES * 64]
  __attribute__ ((section (".rodata"))) ;
extern const u8 highscores_10minutes_digits_tiles
  [NB_HIGHSCORES_DIGITS_TILES * 64]
  __attribute__ ((section (".rodata"))) ;
extern const u8 highscores_15minutes_digits_tiles
  [NB_HIGHSCORES_DIGITS_TILES * 64]
  __attribute__ ((section (".rodata"))) ;
#define HIGHSCORES_DIGIT_SIZE_IN_TILES 2





#define NB_HIGHSCORES_FONTS_TILES 37
extern const u8 highscores_endless_fonts_tiles
  [NB_HIGHSCORES_FONTS_TILES * 64]
  __attribute__ ((section (".rodata"))) ;
extern const u8 highscores_5minutes_fonts_tiles
  [NB_HIGHSCORES_FONTS_TILES * 64]
  __attribute__ ((section (".rodata"))) ;
extern const u8 highscores_10minutes_fonts_tiles
  [NB_HIGHSCORES_FONTS_TILES * 64]
  __attribute__ ((section (".rodata"))) ;
extern const u8 highscores_15minutes_fonts_tiles
  [NB_HIGHSCORES_FONTS_TILES * 64]
  __attribute__ ((section (".rodata"))) ;






/* Endless board. */
#define EMPTY_HIGHSCORES_ENDLESS_DIGIT_TILE_INDEX (NB_ENDLESS_BOTTOM_TILES)
#define ZERO_HIGHSCORES_ENDLESS_DIGIT_TILE_INDEX \
  ((EMPTY_HIGHSCORES_ENDLESS_DIGIT_TILE_INDEX) + \
  (HIGHSCORES_DIGIT_SIZE_IN_TILES))
#define HIGHSCORES_ENDLESS_DIGITS_TILES_LOADING_OFFSET \
   ((ENDLESS_BOTTOM_TILES_LOADING_OFFSET) + \
   (((NB_ENDLESS_BOTTOM_TILES) * 64) / 2))

#define HIGHSCORES_ENDLESS_FONTS_FIRST_TILE_INDEX \
   ((EMPTY_HIGHSCORES_ENDLESS_DIGIT_TILE_INDEX) + (NB_HIGHSCORES_DIGITS_TILES))
#define HIGHSCORES_ENDLESS_FONTS_TILES_LOADING_OFFSET \
   ((HIGHSCORES_ENDLESS_DIGITS_TILES_LOADING_OFFSET) + \
   (((NB_HIGHSCORES_DIGITS_TILES) * 64) / 2))



/* 5 minute board. */
#define EMPTY_HIGHSCORES_FIVE_MINUTES_DIGIT_TILE_INDEX \
  (NB_FIVE_MINUTES_BOTTOM_TILES)
#define ZERO_HIGHSCORES_FIVE_MINUTES_DIGIT_TILE_INDEX \
  ((EMPTY_HIGHSCORES_FIVE_MINUTES_DIGIT_TILE_INDEX) + \
  (HIGHSCORES_DIGIT_SIZE_IN_TILES))
#define HIGHSCORES_FIVE_MINUTES_DIGITS_TILES_LOADING_OFFSET \
   ((FIVE_MINUTES_BOTTOM_TILES_LOADING_OFFSET) + \
   (((NB_FIVE_MINUTES_BOTTOM_TILES) * 64) / 2))

#define HIGHSCORES_FIVE_MINUTES_FONTS_FIRST_TILE_INDEX \
   ((EMPTY_HIGHSCORES_FIVE_MINUTES_DIGIT_TILE_INDEX) + \
    (NB_HIGHSCORES_DIGITS_TILES))
#define HIGHSCORES_FIVE_MINUTES_FONTS_TILES_LOADING_OFFSET \
   ((HIGHSCORES_FIVE_MINUTES_DIGITS_TILES_LOADING_OFFSET) + \
   (((NB_HIGHSCORES_DIGITS_TILES) * 64) / 2))



/* 10 minutes board. */
#define EMPTY_HIGHSCORES_TEN_MINUTES_DIGIT_TILE_INDEX \
  (NB_TEN_MINUTES_BOTTOM_TILES)
#define ZERO_HIGHSCORES_TEN_MINUTES_DIGIT_TILE_INDEX \
  ((EMPTY_HIGHSCORES_TEN_MINUTES_DIGIT_TILE_INDEX) + \
  (HIGHSCORES_DIGIT_SIZE_IN_TILES))
#define HIGHSCORES_TEN_MINUTES_DIGITS_TILES_LOADING_OFFSET \
   ((TEN_MINUTES_BOTTOM_TILES_LOADING_OFFSET) + \
   (((NB_TEN_MINUTES_BOTTOM_TILES) * 64) / 2))

#define HIGHSCORES_TEN_MINUTES_FONTS_FIRST_TILE_INDEX \
   ((EMPTY_HIGHSCORES_TEN_MINUTES_DIGIT_TILE_INDEX) + \
    (NB_HIGHSCORES_DIGITS_TILES))
#define HIGHSCORES_TEN_MINUTES_FONTS_TILES_LOADING_OFFSET \
   ((HIGHSCORES_TEN_MINUTES_DIGITS_TILES_LOADING_OFFSET) + \
   (((NB_HIGHSCORES_DIGITS_TILES) * 64) / 2))



/* 15 minutes board. */
#define EMPTY_HIGHSCORES_FIFTEEN_MINUTES_DIGIT_TILE_INDEX \
  (NB_FIFTEEN_MINUTES_BOTTOM_TILES)
#define ZERO_HIGHSCORES_FIFTEEN_MINUTES_DIGIT_TILE_INDEX \
  ((EMPTY_HIGHSCORES_FIFTEEN_MINUTES_DIGIT_TILE_INDEX) + \
  (HIGHSCORES_DIGIT_SIZE_IN_TILES))
#define HIGHSCORES_FIFTEEN_MINUTES_DIGITS_TILES_LOADING_OFFSET \
   ((FIFTEEN_MINUTES_BOTTOM_TILES_LOADING_OFFSET) + \
   (((NB_FIFTEEN_MINUTES_BOTTOM_TILES) * 64) / 2))

#define HIGHSCORES_FIFTEEN_MINUTES_FONTS_FIRST_TILE_INDEX \
   ((EMPTY_HIGHSCORES_FIFTEEN_MINUTES_DIGIT_TILE_INDEX) + \
    (NB_HIGHSCORES_DIGITS_TILES))
#define HIGHSCORES_FIFTEEN_MINUTES_FONTS_TILES_LOADING_OFFSET \
   ((HIGHSCORES_FIFTEEN_MINUTES_DIGITS_TILES_LOADING_OFFSET) + \
   (((NB_HIGHSCORES_DIGITS_TILES) * 64) / 2))





/* General stuff for all the boards. */
#define HIGHSCORES_SCORE_X_OFFSET (5)
#define HIGHSCORES_LINES_X_OFFSET (17)
#define HIGHSCORES_NAME_X_OFFSET (5)
#define HIGHSCORES_INFOS_STARTING_Y_OFFSET (5)
#define HIGHSCORES_NAME_STARTING_Y_OFFSET (4)
#define LEADING_Y (4)

#define HIGHSCORES_PREV_NEXT_BUTTONS_WIDTH (3 * 8)
#define HIGHSCORES_PREV_NEXT_BUTTONS_HEIGTH (2 * 8)
#define HIGHSCORES_PREV_NEXT_BUTTONS_Y_OFFSET (1 * 8)
#define HIGHSCORES_PREV_X_OFFSET (1 * 8)
#define HIGHSCORES_NEXT_X_OFFSET (28 * 8)

#endif
