#ifndef __PERSISTENT_H__
#define __PERSISTENT_H__

#define TAGTOLONG(a,b,c,d) ((unsigned long)(((a)<<24)|((b)<<16)|((c)<<8)|(d)))
#define MAGICNUMBER TAGTOLONG('Q','B','X','S')

#define NB_HIGHSCORES 5
/* Lenght includes the final \0. */
#define MAX_PLAYER_NAME_LENGTH 11
#define EMPTY_PLAYER_NAME "          "

struct entry {
  u32 score ;
  u32 lines ;
  char player[MAX_PLAYER_NAME_LENGTH] ;
};

struct highscores {
  struct entry endless[NB_HIGHSCORES] ;
  struct entry game_5mn[NB_HIGHSCORES] ;
  struct entry game_10mn[NB_HIGHSCORES] ;
  struct entry game_15mn[NB_HIGHSCORES] ;
};

struct save_data {
  u32 magic_tag ;
  enum keyboard_config keyboard_config ;
  int seed ;
  struct highscores highscores ;
};


extern struct highscores global_highscores ;
void SaveScores () ;
bool ReadScores () ;
s8 CheckIfHighscore (u32 score, u32 lines) ;
void HibernateGame () ;
bool LoadHibernated () ;
void EraseScores () ;

#endif
