#ifndef __SPRITES_GFX_H__
#define __SPRITES_GFX_H__

#define SPRITES_PALETTE_SIZE 255
#define NB_SPRITES_TILES 280

extern const u16 sprites_palette[SPRITES_PALETTE_SIZE]
  __attribute__ ((section (".rodata"))) ;

extern const u8 sprites_tiles[NB_SPRITES_TILES * 64]
  __attribute__ ((section (".rodata"))) ;

#define SPRITES_LOADING_OFFSET (0)
#define FIRST_BUBBLES_TILE_INDEX (0)
#define NB_BUBBLES_FRAMES (8)
#define NB_TILES_PER_BUBBLES_FRAME (16)

/* Yep, * 2 because 256-colors sprites need 2 phical tiles per logical tile. */
#define FIRST_YES_NO_TILE_INDEX \
   (FIRST_BUBBLES_TILE_INDEX + \
   ((NB_BUBBLES_FRAMES * NB_TILES_PER_BUBBLES_FRAME) * 2))
#define NB_YES_NO_TILES 8

#define SCORE_ERASING_POPUP_X (132)
#define SCORE_ERASING_POPUP_Y (100)
#define SCORE_ERASING_BUTTONS_WIDTH (16)
#define SCORE_ERASING_BUTTONS_HEIGHT (16)
#define SCORE_ERASING_NO_X \
  (SCORE_ERASING_POPUP_X)
#define SCORE_ERASING_YES_X \
  (SCORE_ERASING_POPUP_X + SCORE_ERASING_BUTTONS_WIDTH)


#define NB_STYLUS_FRAMES (3)
#define NB_TILES_PER_STYLUS_FRAME (16)
/* Yep, * 2 because 256-colors sprites need 2 phical tiles per logical tile. */
#define FIRST_STYLUS_TILE_INDEX \
   (FIRST_YES_NO_TILE_INDEX + ((NB_YES_NO_TILES) * 2))


#define NB_BRAVO_FRAMES (3)
#define NB_TILES_PER_BRAVO_FRAME (16)
/* Yep, * 2 because 256-colors sprites need 2 phical tiles per logical tile. */
#define FIRST_BRAVO_TILE_INDEX \
   (FIRST_STYLUS_TILE_INDEX + \
   ((NB_STYLUS_FRAMES * NB_TILES_PER_STYLUS_FRAME) * 2))
#define BRAVO_SMILEY_X (3)
#define BRAVO_SMILEY_Y (43)
#define BRAVO_SMILEY_Y_STEP (24)

#endif
