#include <nds.h>
#include <interrupts.h>
#include <timers.h>



volatile u32 global_elapsed_semi_seconds = 0 ;

void Timer2Handler ()
{
  /* Interdit les interruptions. */
  REG_IME = IME_DISABLE ;
  global_elapsed_semi_seconds++ ;
  /* Positionner le flag pour dire que l'on a trait l'interruption. */
  REG_IF |= IRQ_TIMER2 ;
  /* Rtablit les interruptions. */
  REG_IME = IME_ENABLE ;
}


void StartGameTimer ()
{
  TIMER2_DATA = (u16) 0 ;
  TIMER3_DATA = (u16) 0 ;
  /* Frquence pour 0xFFFF correspondant  1/2 s. */
  TIMER2_CR = TIMER_DIV_256 | TIMER_ENABLE | TIMER_IRQ_REQ ;
  /* Timer en cascade pour tester x overflows du timer 2 (=x 1/2 secondes). */
  TIMER3_CR = TIMER_CASCADE | TIMER_ENABLE ;
}




void StopGameTimer ()
{
  /* Arrt du timer. */
  TIMER2_CR &= (~(TIMER_ENABLE | TIMER_IRQ_REQ)) ;
  TIMER3_CR &= (~(TIMER_ENABLE | TIMER_IRQ_REQ)) ;
}


/*
void SuspendGameTimer ()
{
  TIMER2_DATA &= (~TIMER_ENABLE) ;
}



void RestartGameTimer ()
{
  TIMER2_DATA |= TIMER_ENABLE ;
}
*/
